// prepreka
// s ključavnicami, pravilno ponavljanje zanke s sistemom treh ključavnic:
//   1. naredi glavno prepreko
//   2. po naslednji prepreki resetiramo števec (če ga ne, kakšna nit ne pride preko prve prepreke)
//   3. še ena prepreka je potrebna, da nam kakšna nit prezgodaj ne pobegne do prve prepreke

#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#include <Windows.h>

#define	NTHREADS	4
#define NPRINTS		5

int threads, threads2, threads3;
int shared;
pthread_mutex_t lock;

void* barrier(void* arg) 
{
	int i;
	int myid = (int)arg;

	for(i=0; i<NPRINTS; i++)
	{
		if( myid == 0 )
			shared++;

		// prepreka - zacetek
		pthread_mutex_lock(&lock);
		threads++;
		pthread_mutex_unlock(&lock);
		while( threads < NTHREADS );
		// prepreka - konec

		printf("Nit %d: vrednost: %d\n", myid, shared);

		if( myid == 0 )
			threads3 = 0;

		// prepreka 2 - zacetek
		pthread_mutex_lock(&lock);
		threads2++;
		pthread_mutex_unlock(&lock);
		while( threads2 < NTHREADS );
		// prepreka - konec

		if( myid == 0 )
			threads = 0;

		// prepreka 3 - zacetek
		pthread_mutex_lock(&lock);
		threads3++;
		pthread_mutex_unlock(&lock);
		while( threads3 < NTHREADS );
		// prepreka 3 - konec

		if( myid == 0 )
			threads2 = 0;
	}

	return NULL;
}

int main(int argc, char *argv[]) 
{
	int i;
	pthread_t t[NTHREADS];

	shared = 0;
	threads = threads2 = threads3 = 0;

	pthread_mutex_init(&lock, NULL);

	for(i=0; i<NTHREADS; i++)
		pthread_create(&t[i], NULL, barrier, (void *)i);

	for(i=0; i<NTHREADS; i++)
		pthread_join(t[i], NULL);

	pthread_mutex_destroy(&lock);

	return 0;
}
